<%@ attribute name="bazaarvoiceDCCProductData" required="true" type="java.util.HashMap" %>
<%@ tag body-content="empty" trimDirectiveWhitespaces="true" %>

<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ tag trimDirectiveWhitespaces="true" %>
<%@taglib prefix="s" uri="http://www.springframework.org/tags" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="ycommerce" uri="http://hybris.com/tld/ycommercetags" %>

<script async type="text/javascript">
    window.bvDCC = {
        catalogData: {
            locale: "${cmsSite.bvLocale}",
            catalogProducts: [
                <c:forEach items="${bazaarvoiceDCCProductData}" var="mapEntry" varStatus="pStatus">
                {
                    <s:eval expression="T(com.bazaarvoice.hybris.utils.BazaarVoiceUtils).ReplaceUnsupportedCharacters(mapEntry.key.code)" var="productCode"/>
                    <s:eval expression="T(com.bazaarvoice.hybris.utils.BazaarVoiceUtils).removeHtml(mapEntry.key.description)" var="productDescription"/>
                    <c:choose>
                    <c:when test="${cmsSite.bvConfig.productPrefixEnabled}">
                    "productId": "${cmsSite.uid}-${productCode}",
                    </c:when>
                    <c:otherwise>
                    "productId": "${productCode}",
                    </c:otherwise>
                    </c:choose>
                    "productName": "${mapEntry.key.name}",
                    "productDescription": "${productDescription}",
                    "productImageURL": "${ycommerce:encodeUrl(mapEntry.value.imageUrl)}",
                    "productPageURL": "${ycommerce:encodeUrl(mapEntry.value.productPageUrl)}",
                    "brandName": "${mapEntry.key.manufacturer}",
                    "categoryPath": [
                        <c:choose>
                        <c:when test="${cmsSite.bvConfig.storeLevelCategoriesEnabled}">
                        {
                            "id": "${cmsSite.uid}",
                            "Name": "${cmsSite.name}"
                        }
                        ,
                        </c:when>
                        <c:otherwise>
                        </c:otherwise>
                        </c:choose>
                        <c:forEach items="${mapEntry.key.categories}" var="category" varStatus="cStatus">
                        {
                            <c:choose>
                            <c:when test="${cmsSite.bvConfig.storeLevelCategoriesEnabled}">
                            "id": "${cmsSite.uid}-${category.code}",
                            "Name": "${category.name}"
                            </c:when>
                            <c:otherwise>
                            "id": "${category.code}",
                            "Name": "${category.name}"
                            </c:otherwise>
                            </c:choose>
                        }
                        <c:if test="${not cStatus.last}">, </c:if>
                        </c:forEach>
                    ],
                    <c:choose>
                    <c:when test="${mapEntry.value.upcs eq null or empty mapEntry.value.upcs}">
                    </c:when>
                    <c:otherwise>
                    "upcs": [
                        <c:forEach items="${mapEntry.value.upcs}" var="upc" varStatus="cStatus">
                        "${upc}"
                        <c:if test="${not cStatus.last}">, </c:if>
                        </c:forEach>
                    ],

                    </c:otherwise>
                    </c:choose>

                    <c:choose>
                    <c:when test="${mapEntry.value.manufacturerAID eq null}">
                    </c:when>
                    <c:otherwise>
                    "manufacturerPartNumbers": ["${mapEntry.value.manufacturerAID}"],
                    </c:otherwise>
                    </c:choose>

                    <c:choose>
                    <c:when test="${mapEntry.value.eans eq null or empty mapEntry.value.eans}">
                    </c:when>
                    <c:otherwise>
                    "eans": [
                        <c:forEach items="${mapEntry.value.eans}" var="ean" varStatus="cStatus">
                        "${ean}"
                        <c:if test="${not cStatus.last}">, </c:if>
                        </c:forEach>
                    ],
                    </c:otherwise>
                    </c:choose>

                    "family": "${mapEntry.value.familyName}"
                }
                <c:if test="${not pStatus.last}">, </c:if>
                </c:forEach>
            ]
        }
    };

    window.bvCallback = function (BV) {
        // Use a loop for multiple products
        for (var i = 0, len = window.bvDCC.catalogData.catalogProducts.length; i < len; ++i) {
            BV.pixel.trackEvent("CatalogUpdate", {
                type: 'Product',
                locale: window.bvDCC.catalogData.locale,
                catalogProducts: [window.bvDCC.catalogData.catalogProducts[i]]
            });
        }
    };
</script>
<p hidden>Bazaarvoice SAP Hybris Integration Version ${cmsSite.bvConfig.extensionVersion}
</p>